"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditUser = void 0;
const react_1 = __importStar(require("react"));
const eui_1 = require("@elastic/eui");
const useApiRequest_1 = require("../../common/hooks/useApiRequest");
const wz_request_1 = require("../../../react-services/wz-request");
exports.EditUser = ({ currentUser, closeFlyout, userRoles, rolesObject }) => {
    const userRolesFormatted = userRoles && userRoles.length ? userRoles.map(item => { return { label: rolesObject[item], id: item }; }) : [];
    const [selectedRoles, setSelectedRole] = react_1.useState(userRolesFormatted);
    const [rolesParams, setRoleParams] = react_1.useState({});
    const [rolesLoading, roles, rolesError] = useApiRequest_1.useApiRequest('GET', '/security/roles', rolesParams);
    const rolesOptions = roles.affected_items ? roles.affected_items.map(item => { return { label: item.name, id: item.id }; }) : [];
    const [rulesParams, setRuleParams] = react_1.useState({ search: `wui_${currentUser.user}` });
    const [rulesLoading, rules, rulesError] = useApiRequest_1.useApiRequest('GET', '/security/rules', rulesParams);
    var userRules = rules.affected_items ? rules.affected_items.filter(item => { return item.name === `wui_${currentUser.user}`; }) : [];
    const [isLoading, setIsLoading] = react_1.useState(false);
    const editUser = async () => {
        setIsLoading(true);
        const formattedRoles = selectedRoles.map(item => {
            return item.id;
        });
        if (!userRules.length) {
            const data = await wz_request_1.WzRequest.apiReq('POST', '/security/rules', {
                "name": `wui_${currentUser.user}`,
                "rule": {
                    "FIND": {
                        "r'user_?name'": `${currentUser.user}`
                    }
                }
            });
            userRules = ((data.data || {}).data || {}).affected_items || [];
        }
        const ruleId = (userRules[0] || {}).id || false;
        if (ruleId) {
            const toAdd = formattedRoles.filter(value => !userRoles.includes(value));
            const toRemove = userRoles.filter(value => !formattedRoles.includes(value));
            await Promise.all(toAdd.map(async (role) => {
                const data = await wz_request_1.WzRequest.apiReq('POST', `/security/roles/${role}/rules`, {
                    params: {
                        rule_ids: ruleId
                    }
                });
            }));
            await Promise.all(toRemove.map(async (role) => {
                const data = await wz_request_1.WzRequest.apiReq('DELETE', `/security/roles/${role}/rules`, {
                    params: {
                        rule_ids: ruleId
                    }
                });
            }));
        }
        closeFlyout(false);
    };
    const onChangeRoles = selectedRoles => {
        setSelectedRole(selectedRoles);
    };
    return (react_1.default.createElement(eui_1.EuiFlyout, { onClose: () => closeFlyout() },
        react_1.default.createElement(eui_1.EuiFlyoutHeader, { hasBorder: false },
            react_1.default.createElement(eui_1.EuiTitle, { size: "m" },
                react_1.default.createElement("h2", null,
                    "Edit ",
                    currentUser.user,
                    " user \u00A0 \u00A0",
                    currentUser.user === 'elastic' || currentUser.user === 'admin' &&
                        react_1.default.createElement(eui_1.EuiBadge, { color: 'primary' }, "Reserved")))),
        react_1.default.createElement(eui_1.EuiFlyoutBody, null,
            react_1.default.createElement(eui_1.EuiForm, { component: "form", style: { padding: 24 } },
                react_1.default.createElement(eui_1.EuiFormRow, { label: "Roles", helpText: "Assign roles to the selected user" },
                    react_1.default.createElement(eui_1.EuiComboBox, { placeholder: "Select roles", options: rolesOptions, selectedOptions: selectedRoles, isLoading: rulesLoading || isLoading, onChange: onChangeRoles, isClearable: true, "data-test-subj": "demoComboBox" })),
                react_1.default.createElement(eui_1.EuiSpacer, null),
                react_1.default.createElement(eui_1.EuiFlexGroup, null,
                    react_1.default.createElement(eui_1.EuiFlexItem, { grow: false },
                        react_1.default.createElement(eui_1.EuiButton, { fill: true, isLoading: isLoading, isDisabled: currentUser.user === 'elastic' || currentUser.user === 'admin', onClick: editUser }, "Apply")))))));
};
